/*@lineinfo:filename=IteratorFromResultSet*//*@lineinfo:user-code*//*@lineinfo:1^1*///Exemple de conversion d'un ResultSet JDBC en itrateur SQLJ
package ExemplesSQLJ;

import sqlj.runtime.*;
import sqlj.runtime.ref.*;
import java.sql.*;

// Dfinition de la classe IteratorClient avec liaison par nom
/*@lineinfo:generated-code*//*@lineinfo:9^1*/

//  ************************************************************
//  SQLJ iterator declaration:
//  ************************************************************

public class IteratorClient
extends sqlj.runtime.ref.ResultSetIterImpl
implements sqlj.runtime.NamedIterator
{
  public IteratorClient(sqlj.runtime.profile.RTResultSet resultSet)
    throws java.sql.SQLException
  {
    super(resultSet);
    noClientNdx = findColumn("noClient");
    nomClientNdx = findColumn("nomClient");
    m_rs = (oracle.jdbc.OracleResultSet) resultSet.getJDBCResultSet();
  }
  private oracle.jdbc.OracleResultSet m_rs;
  public int noClient()
    throws java.sql.SQLException
  {
    int __sJtmp = m_rs.getInt(noClientNdx);
    if (m_rs.wasNull()) throw new sqlj.runtime.SQLNullException(); else return __sJtmp;
  }
  private int noClientNdx;
  public String nomClient()
    throws java.sql.SQLException
  {
    return m_rs.getString(nomClientNdx);
  }
  private int nomClientNdx;
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:9^67*/

public class IteratorFromResultSet{
    public static void main (String args [])
       throws SQLException, ClassNotFoundException, java.io.IOException
  {
    // Charger le pilote JDBC d'Oracle
    Class.forName ("oracle.jdbc.driver.OracleDriver");

    // Cration du contexte de connexion de dfaut avec autocommit (true)
    DefaultContext unContext = new DefaultContext
          ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle", true);
    DefaultContext.setDefaultContext(unContext);

    // Chercher la Connection de unContexte
    Connection uneConnection = DefaultContext.getDefaultContext().getConnection();

    // Cration d'un nonc associ  la Connexion
    Statement unEnoncSQL = uneConnection.createStatement();

    // Excution d'un SELECT
    ResultSet unResultSet = unEnoncSQL.executeQuery
     ("SELECT noClient, nomClient "+
     "FROM CLIENT " +
     "WHERE noClient > 40");


    // Cration d'un objet itrateur
    IteratorClient unIteratorClient;

    // Conversion du ResultSet en itrateur
    /*@lineinfo:generated-code*//*@lineinfo:40^5*/

//  ************************************************************
//  #sql unIteratorClient = { CAST :unResultSet };
//  ************************************************************

 unIteratorClient = new ExemplesSQLJ.IteratorClient(new sqlj.runtime.ref.OraRTResultSet(unResultSet));


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:40^47*/

    // Accs  l'itrateur
    while (unIteratorClient.next()){
      System.out.println("Numro du client : " + unIteratorClient.noClient());
      System.out.println("Nom du client : " + unIteratorClient.nomClient());
    }

    // Fermer l'itrateur
    unIteratorClient.close();
  }
}/*@lineinfo:generated-code*/